package kr.co.vividnext.sodalive.user

import io.reactivex.rxjava3.core.Single
import kr.co.vividnext.sodalive.common.ApiResponse
import kr.co.vividnext.sodalive.main.PushTokenUpdateRequest
import kr.co.vividnext.sodalive.mypage.MyPageResponse
import kr.co.vividnext.sodalive.settings.notification.UpdateNotificationSettingRequest
import kr.co.vividnext.sodalive.user.find_password.ForgotPasswordRequest
import kr.co.vividnext.sodalive.user.login.LoginRequest
import okhttp3.MultipartBody
import okhttp3.RequestBody

class UserRepository(private val userApi: UserApi) {
    fun login(request: LoginRequest) = userApi.login(request)

    fun signUp(profileImage: MultipartBody.Part?, request: RequestBody) = userApi.signUp(
        profileImage,
        request
    )

    fun findPassword(request: ForgotPasswordRequest) = userApi.findPassword(request = request)

    fun updateNotificationSettings(
        request: UpdateNotificationSettingRequest,
        token: String
    ) = userApi.updateNotificationSettings(request, authHeader = token)

    fun updatePushToken(
        request: PushTokenUpdateRequest,
        token: String
    ) = userApi.updatePushToken(request, authHeader = token)

    fun getMemberInfo(token: String) = userApi.getMemberInfo(authHeader = token)

    fun getMyPage(token: String): Single<ApiResponse<MyPageResponse>> {
        return userApi.getMyPage(authHeader = token)
    }
}
